STRUCT TEMPLATE IM(3)

NAME
boost::proto::lazy::impl

SYNOPSIS

// In header: <boost/proto/transform/lazy.hpp>
template<typename Expr, typename State, typename Data>
struct impl :  proto::transform_impl<Expr, State, Data> {
  // types
  typedef see-below result_type;
  // public member functions
  result_type operator()(typename impl::expr_param,
                         typename impl::state_param,
                         typename impl::data_param) const;
};

DESCRIPTION

  impl public types

    1. typedef see-below result_type;

    proto::lazy<T>::impl<Expr,State,Data>::result_type is calculated as follows:

        &#8226; If T if of the form O(A0,...An), then let O' be boost::result_of<proto::make<O>(Expr, State, Data)>::type and let T' be O'(A0,...An).

        &#8226; Otherwise, let T' be boost::result_of<proto::make<T>(Expr, State, Data)>::type.
        The result type is boost::result_of<proto::call<T'>(Expr, State, Data)>::type.

  impl public member functions

    1.

    result_type operator()(typename impl::expr_param expr,
                           typename impl::state_param state,
                           typename impl::data_param data) const;

    proto::lazy<T>::impl<Expr,State,Data>::operator() behaves as follows:

        &#8226; If T if of the form O(A0,...An), then let O' be boost::result_of<proto::make<O>(Expr, State, Data)>::type and let T' be O'(A0,...An).

        &#8226; Otherwise, let T' be boost::result_of<proto::make<T>(Expr, State, Data)>::type.

        Returns:
            proto::call<T'>()(expr, state, data)